package org.seamframework.sql;

import java.sql.SQLException;
import java.util.List;

public class ExecutableQuery extends ExecutableStatement {

	final List<Expression<?>> selections;
	
	public ExecutableQuery(Query query, Session session) {
		super(query, session);
		selections = query.getSelections();
	}
	
	@Override
	public <T> ExecutableQuery set(Parameter<T> param, T value) {
		super.set(param, value);
		return this;
	}
	
	public Iterable<Tuple> result() {
		try {
			return new Result( getPreparedStatement().executeQuery(), selections );
		}
		catch (SQLException sqle) {
			throw new RuntimeException(sqle);
		}
	}
	
}
