package org.seamframework.sql;

import java.util.List;
import java.util.NoSuchElementException;

public class Tuple {
	
	private final List<Expression<?>> selections;
	private final List<Object> elements;
	
	Tuple(List<Expression<?>> selections, List<Object> values) {
		this.selections = selections;
		this.elements = values;
	}

	@SuppressWarnings("unchecked")
	public <T> T get(Selection<T> selection) {
		int ind = selections.indexOf(selection);
		if (ind<0) throw new NoSuchElementException();
		return (T) elements.get( ind );
	}

	public List<Expression<?>> getSelections() {
		return selections;
	}

	public List<Object> getElements() {
		return elements;
	}

}
